=begin
#Conekta API

#Conekta sdk

The version of the OpenAPI document: 2.2.0
Contact: engineering@conekta.com
Generated by: https://openapi-generator.tech
Generator version: 7.5.0

=end

require 'cgi'

module Conekta
  class DiscountsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Discount
    # Create discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param order_discount_lines_request [OrderDiscountLinesRequest] requested field for a discount lines
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [DiscountLinesResponse]
    def orders_create_discount_line(id, order_discount_lines_request, opts = {})
      data, _status_code, _headers = orders_create_discount_line_with_http_info(id, order_discount_lines_request, opts)
      data
    end

    # Create Discount
    # Create discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param order_discount_lines_request [OrderDiscountLinesRequest] requested field for a discount lines
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [Array<(DiscountLinesResponse, Integer, Hash)>] DiscountLinesResponse data, response status code and response headers
    def orders_create_discount_line_with_http_info(id, order_discount_lines_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DiscountsApi.orders_create_discount_line ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling DiscountsApi.orders_create_discount_line"
      end
      # verify the required parameter 'order_discount_lines_request' is set
      if @api_client.config.client_side_validation && order_discount_lines_request.nil?
        fail ArgumentError, "Missing the required parameter 'order_discount_lines_request' when calling DiscountsApi.orders_create_discount_line"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/orders/{id}/discount_lines'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(order_discount_lines_request)

      # return_type
      return_type = opts[:debug_return_type] || 'DiscountLinesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"DiscountsApi.orders_create_discount_line",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DiscountsApi#orders_create_discount_line\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete Discount
    # Delete an existing discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param discount_lines_id [String] discount line id identifier
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [DiscountLinesResponse]
    def orders_delete_discount_lines(id, discount_lines_id, opts = {})
      data, _status_code, _headers = orders_delete_discount_lines_with_http_info(id, discount_lines_id, opts)
      data
    end

    # Delete Discount
    # Delete an existing discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param discount_lines_id [String] discount line id identifier
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [Array<(DiscountLinesResponse, Integer, Hash)>] DiscountLinesResponse data, response status code and response headers
    def orders_delete_discount_lines_with_http_info(id, discount_lines_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DiscountsApi.orders_delete_discount_lines ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling DiscountsApi.orders_delete_discount_lines"
      end
      # verify the required parameter 'discount_lines_id' is set
      if @api_client.config.client_side_validation && discount_lines_id.nil?
        fail ArgumentError, "Missing the required parameter 'discount_lines_id' when calling DiscountsApi.orders_delete_discount_lines"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/orders/{id}/discount_lines/{discount_lines_id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s)).sub('{' + 'discount_lines_id' + '}', CGI.escape(discount_lines_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'DiscountLinesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"DiscountsApi.orders_delete_discount_lines",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DiscountsApi#orders_delete_discount_lines\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Discount
    # Get an existing discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param discount_lines_id [String] discount line id identifier
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [DiscountLinesResponse]
    def orders_get_discount_line(id, discount_lines_id, opts = {})
      data, _status_code, _headers = orders_get_discount_line_with_http_info(id, discount_lines_id, opts)
      data
    end

    # Get Discount
    # Get an existing discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param discount_lines_id [String] discount line id identifier
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [Array<(DiscountLinesResponse, Integer, Hash)>] DiscountLinesResponse data, response status code and response headers
    def orders_get_discount_line_with_http_info(id, discount_lines_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DiscountsApi.orders_get_discount_line ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling DiscountsApi.orders_get_discount_line"
      end
      # verify the required parameter 'discount_lines_id' is set
      if @api_client.config.client_side_validation && discount_lines_id.nil?
        fail ArgumentError, "Missing the required parameter 'discount_lines_id' when calling DiscountsApi.orders_get_discount_line"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/orders/{id}/discount_lines/{discount_lines_id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s)).sub('{' + 'discount_lines_id' + '}', CGI.escape(discount_lines_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'DiscountLinesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"DiscountsApi.orders_get_discount_line",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DiscountsApi#orders_get_discount_line\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a List of Discount
    # Get discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @option opts [Integer] :limit The numbers of items to return, the maximum value is 250 (default to 20)
    # @option opts [String] :search General order search, e.g. by mail, reference etc.
    # @option opts [String] :_next next page
    # @option opts [String] :previous previous page
    # @return [GetOrderDiscountLinesResponse]
    def orders_get_discount_lines(id, opts = {})
      data, _status_code, _headers = orders_get_discount_lines_with_http_info(id, opts)
      data
    end

    # Get a List of Discount
    # Get discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @option opts [Integer] :limit The numbers of items to return, the maximum value is 250 (default to 20)
    # @option opts [String] :search General order search, e.g. by mail, reference etc.
    # @option opts [String] :_next next page
    # @option opts [String] :previous previous page
    # @return [Array<(GetOrderDiscountLinesResponse, Integer, Hash)>] GetOrderDiscountLinesResponse data, response status code and response headers
    def orders_get_discount_lines_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DiscountsApi.orders_get_discount_lines ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling DiscountsApi.orders_get_discount_lines"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      if @api_client.config.client_side_validation && !opts[:'limit'].nil? && opts[:'limit'] > 250
        fail ArgumentError, 'invalid value for "opts[:"limit"]" when calling DiscountsApi.orders_get_discount_lines, must be smaller than or equal to 250.'
      end

      if @api_client.config.client_side_validation && !opts[:'limit'].nil? && opts[:'limit'] < 1
        fail ArgumentError, 'invalid value for "opts[:"limit"]" when calling DiscountsApi.orders_get_discount_lines, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/orders/{id}/discount_lines'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'next'] = opts[:'_next'] if !opts[:'_next'].nil?
      query_params[:'previous'] = opts[:'previous'] if !opts[:'previous'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'GetOrderDiscountLinesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"DiscountsApi.orders_get_discount_lines",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DiscountsApi#orders_get_discount_lines\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update Discount
    # Update an existing discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param discount_lines_id [String] discount line id identifier
    # @param update_order_discount_lines_request [UpdateOrderDiscountLinesRequest] requested field for a discount lines
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [DiscountLinesResponse]
    def orders_update_discount_lines(id, discount_lines_id, update_order_discount_lines_request, opts = {})
      data, _status_code, _headers = orders_update_discount_lines_with_http_info(id, discount_lines_id, update_order_discount_lines_request, opts)
      data
    end

    # Update Discount
    # Update an existing discount lines for an existing orden
    # @param id [String] Identifier of the resource
    # @param discount_lines_id [String] discount line id identifier
    # @param update_order_discount_lines_request [UpdateOrderDiscountLinesRequest] requested field for a discount lines
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [Array<(DiscountLinesResponse, Integer, Hash)>] DiscountLinesResponse data, response status code and response headers
    def orders_update_discount_lines_with_http_info(id, discount_lines_id, update_order_discount_lines_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DiscountsApi.orders_update_discount_lines ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling DiscountsApi.orders_update_discount_lines"
      end
      # verify the required parameter 'discount_lines_id' is set
      if @api_client.config.client_side_validation && discount_lines_id.nil?
        fail ArgumentError, "Missing the required parameter 'discount_lines_id' when calling DiscountsApi.orders_update_discount_lines"
      end
      # verify the required parameter 'update_order_discount_lines_request' is set
      if @api_client.config.client_side_validation && update_order_discount_lines_request.nil?
        fail ArgumentError, "Missing the required parameter 'update_order_discount_lines_request' when calling DiscountsApi.orders_update_discount_lines"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/orders/{id}/discount_lines/{discount_lines_id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s)).sub('{' + 'discount_lines_id' + '}', CGI.escape(discount_lines_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(update_order_discount_lines_request)

      # return_type
      return_type = opts[:debug_return_type] || 'DiscountLinesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"DiscountsApi.orders_update_discount_lines",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DiscountsApi#orders_update_discount_lines\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
