=begin
#Conekta API

#Conekta sdk

The version of the OpenAPI document: 2.2.0
Contact: engineering@conekta.com
Generated by: https://openapi-generator.tech
Generator version: 7.5.0

=end

require 'cgi'

module Conekta
  class ShippingsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Shipping
    # Create new shipping for an existing orden
    # @param id [String] Identifier of the resource
    # @param shipping_request [ShippingRequest] requested field for a shipping
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [ShippingOrderResponse]
    def orders_create_shipping(id, shipping_request, opts = {})
      data, _status_code, _headers = orders_create_shipping_with_http_info(id, shipping_request, opts)
      data
    end

    # Create Shipping
    # Create new shipping for an existing orden
    # @param id [String] Identifier of the resource
    # @param shipping_request [ShippingRequest] requested field for a shipping
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [Array<(ShippingOrderResponse, Integer, Hash)>] ShippingOrderResponse data, response status code and response headers
    def orders_create_shipping_with_http_info(id, shipping_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ShippingsApi.orders_create_shipping ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling ShippingsApi.orders_create_shipping"
      end
      # verify the required parameter 'shipping_request' is set
      if @api_client.config.client_side_validation && shipping_request.nil?
        fail ArgumentError, "Missing the required parameter 'shipping_request' when calling ShippingsApi.orders_create_shipping"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/orders/{id}/shipping_lines'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(shipping_request)

      # return_type
      return_type = opts[:debug_return_type] || 'ShippingOrderResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"ShippingsApi.orders_create_shipping",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ShippingsApi#orders_create_shipping\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete Shipping
    # Delete shipping
    # @param id [String] Identifier of the resource
    # @param shipping_id [String] identifier
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [ShippingOrderResponse]
    def orders_delete_shipping(id, shipping_id, opts = {})
      data, _status_code, _headers = orders_delete_shipping_with_http_info(id, shipping_id, opts)
      data
    end

    # Delete Shipping
    # Delete shipping
    # @param id [String] Identifier of the resource
    # @param shipping_id [String] identifier
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [Array<(ShippingOrderResponse, Integer, Hash)>] ShippingOrderResponse data, response status code and response headers
    def orders_delete_shipping_with_http_info(id, shipping_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ShippingsApi.orders_delete_shipping ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling ShippingsApi.orders_delete_shipping"
      end
      # verify the required parameter 'shipping_id' is set
      if @api_client.config.client_side_validation && shipping_id.nil?
        fail ArgumentError, "Missing the required parameter 'shipping_id' when calling ShippingsApi.orders_delete_shipping"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/orders/{id}/shipping_lines/{shipping_id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s)).sub('{' + 'shipping_id' + '}', CGI.escape(shipping_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ShippingOrderResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"ShippingsApi.orders_delete_shipping",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ShippingsApi#orders_delete_shipping\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update Shipping
    # Update existing shipping for an existing orden
    # @param id [String] Identifier of the resource
    # @param shipping_id [String] identifier
    # @param shipping_request [ShippingRequest] requested field for a shipping
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [ShippingOrderResponse]
    def orders_update_shipping(id, shipping_id, shipping_request, opts = {})
      data, _status_code, _headers = orders_update_shipping_with_http_info(id, shipping_id, shipping_request, opts)
      data
    end

    # Update Shipping
    # Update existing shipping for an existing orden
    # @param id [String] Identifier of the resource
    # @param shipping_id [String] identifier
    # @param shipping_request [ShippingRequest] requested field for a shipping
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Use for knowing which language to use (default to 'es')
    # @option opts [String] :x_child_company_id In the case of a holding company, the company id of the child company to which will process the request.
    # @return [Array<(ShippingOrderResponse, Integer, Hash)>] ShippingOrderResponse data, response status code and response headers
    def orders_update_shipping_with_http_info(id, shipping_id, shipping_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ShippingsApi.orders_update_shipping ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling ShippingsApi.orders_update_shipping"
      end
      # verify the required parameter 'shipping_id' is set
      if @api_client.config.client_side_validation && shipping_id.nil?
        fail ArgumentError, "Missing the required parameter 'shipping_id' when calling ShippingsApi.orders_update_shipping"
      end
      # verify the required parameter 'shipping_request' is set
      if @api_client.config.client_side_validation && shipping_request.nil?
        fail ArgumentError, "Missing the required parameter 'shipping_request' when calling ShippingsApi.orders_update_shipping"
      end
      allowable_values = ["es", "en"]
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !allowable_values.include?(opts[:'accept_language'])
        fail ArgumentError, "invalid value for \"accept_language\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/orders/{id}/shipping_lines/{shipping_id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s)).sub('{' + 'shipping_id' + '}', CGI.escape(shipping_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.conekta-v2.2.0+json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'X-Child-Company-Id'] = opts[:'x_child_company_id'] if !opts[:'x_child_company_id'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(shipping_request)

      # return_type
      return_type = opts[:debug_return_type] || 'ShippingOrderResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['bearerAuth']

      new_options = opts.merge(
        :operation => :"ShippingsApi.orders_update_shipping",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ShippingsApi#orders_update_shipping\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
